#include <stdio.h>

static unsigned rol16(unsigned n, unsigned r)
	{
	return (n<<r)|(n>>(16-r));
	}

static unsigned prng16(unsigned *p, unsigned *q)
	{
	unsigned pxq = *p^*q;
	unsigned np = rol16(*p,14) ^ pxq ^ (pxq<<2);
	unsigned nq = rol16(pxq, 7);
	*p = np&0xffff;
	*q = nq&0xffff;
	return (np+nq) & 0xffff;
	}

static unsigned rol17(unsigned n, unsigned r)
	{
	return (n<<r)|(n>>(17-r));
	}

static unsigned prng17(unsigned *p, unsigned *q)
	{
	unsigned pxq = *p^*q;
	unsigned np = rol17(*p,7) ^ pxq ^ (pxq<<8);
	unsigned nq = rol17(pxq, 12);
	*p = np&0x1ffff;
	*q = nq&0x1ffff;
	return ( (np+nq) & 0x1ffff ) >> 1;
	}

static void find_p_q(unsigned r1, unsigned r2)
	{
	unsigned i, p = 1, q = 0, p_prev, q_prev, p_prev2, q_prev2, r_prev = 0;
	for ( i = 0; i < 0xffffffff; i++ )
		{
		unsigned r = prng16(&p,&q);
		if ( r_prev == r1 && r == r2 )
			printf("==> p=%04x,q=%04x\n", p_prev2, q_prev2);
		p_prev2 = p_prev; p_prev = p;
		q_prev2 = q_prev; q_prev = q;
		r_prev = r;
		}
	}

int main(void)
	{
	unsigned i, p, q;
	p = 1; q = 0;
//	p=0xa53f; q=0xc7ac;
//	p=0x5bef; q=0xa0b3;
//	p=0x1edb; q=0x32f3;
	for ( i = 0; i < 8; i++ )
		{
		unsigned r = prng16(&p,&q);
		printf("%04x (p=%04x,q=%04x)\n", r, p, q);
		}
	p = 1; q = 0;
	for ( i = 0; i < 8; i++ )
		{
		unsigned r = prng17(&p,&q);
		printf("%04x (p=%05x,q=%05x)\n", r, p, q);
		}

//	find_p_q(0x4b41,0x7965); // "AKey" => p=0xa53f,q=0xc7ac
//	find_p_q(0x6f54,0x796e); // "Tony" => p=0x5bef,q=0xa0b3 or p=0x1edb,q=0x32f3

	return 0;
	}
